fname = GetOpenFileName \
caption:"Open MGS4 Model File" \
types:"MGS4 Model File(*.mdn)|*.mdn" \
historyCategory:"MGS4 ObjectPresets"
f = fopen fname "rb"

if (heapSize < 20000000) then
	heapSize = 40000000 -- allow ~ 40 MB instead of just 7.5 MB. Prevents "Runtime Error: Out of scripter memory"

fn PrintOffset Var =
(
	local Var = Var
print ("This is the offset 0x" + (bit.intAsHex Var) as string)
	Var
)
fn PrintCount Var =
(
	local Var = Var
print ("This is the Count 0x" + (bit.intAsHex Var) as string)
	Var
)

fn floatSwap2 f = 
(
	i = bit.floatAsInt f
	h = bit.intashex i
	while h.count < 8 do h = "0" + h
	
	s = (substring h 7 2) + (substring h 5 2) + (substring h 3 2) + (substring h 1 2)
	bit.intAsFloat (bit.hexasint s)
)	

fn ReadBEword fstream = (
return (bit.swapBytes (readshort fstream #unsigned) 1 2)
)

fn ReadBELong fstream = (
long = readlong fstream
long = bit.swapBytes long 1 4
long = bit.swapBytes long 2 3
return long
)

fn ReadBEfloat fstream = (
return floatSwap2(readfloat fstream)
)

 	fn convertTo32 input16 = (
 		inputAsInt = input16
 		sign = bit.get inputAsInt 16
 		exponent = (bit.shift (bit.and inputAsInt (bit.hexasint "7C00")) -10) as integer - 16
 		fraction = bit.and inputAsInt (bit.hexasint "03FF")
 		if sign==true then sign = 1 else sign = 0
 		exponentF = exponent + 127
 		--Ouput 32 bit integer representing a 32 bit float
 		outputAsFloat = bit.or (bit.or (bit.shift fraction 13) (bit.shift exponentF 23)) (bit.shift sign 31)
 		--Output Check	
 		return bit.intasfloat outputasfloat
 	)

fn ReadBEHalfFloat fstream = (
return convertTo32(ReadBEword fstream) * 2
)

struct weight_data
(
   boneids,weights
)

MdnStart = ftell f
MDN = ReadBELong f
Offset1 = ReadBELong f -- 00 32 F0 0E
BoneCount = ReadBELong f  -- 00 00 00 27
Count2 = ReadBELong f  -- 00 00 00 03
MeshCount1 = ReadBELong f  -- 00 00 00 06
FaceCount = ReadBELong f  -- 00 00 00 0E
MeshCount2 = ReadBELong f  -- 00 00 00 06
Count6 = ReadBELong f  -- 00 00 00 0A
Count7 = ReadBELong f  -- 00 00 00 12
Count8 = ReadBELong f  -- 00 00 00 06
BoneOff = ReadBELong f  -- 00 00 00 80
Offset2 = ReadBELong f  -- 00 00 0C B0
VertCountOff = ReadBELong f  -- 00 00 0C E0
FaceCountOff = ReadBELong f  -- 00 00 0E C0
VertSizeOff = ReadBELong f  -- 00 00 0F A0
Offset6 = ReadBELong f  -- 00 00 10 C0
Offset7 = ReadBELong f  -- 00 00 15 20
BonePalletOff = ReadBELong f  -- 00 00 17 60
VertexOff1 = ReadBELong f  -- 00 00 18 50
VertSection1 = ReadBELong f  -- 00 01 65 B0
FaceOff1 = ReadBELong f  -- 00 01 7E 00
Offset12 = ReadBELong f  -- 00 00 55 A0
Offset13 = ReadBELong f  -- 00 00 00 00
FaceEnd = ReadBELong f  -- 00 01 D3 A0

VertStart = (MdnStart + VertexOff1)
FaceStart = (MdnStart + FaceOff1)


fseek f BoneOff#seek_set

BNArr = #()
for a = 1 to BoneCount Do (
BName = (ReadBELong f) as string
b0y = ReadBELong f
bparent = ReadBELong f + 1
b0w = ReadBELong f
b1x = ReadBEfloat f
b1y = ReadBEfloat f
b1z = ReadBEfloat f
b1w = ReadBEfloat f	
b2x = ReadBEfloat f
b2y = ReadBEfloat f
b2z = ReadBEfloat f
b2w = ReadBEfloat f
fseek f 0x10#seek_cur
fseek f 0x10#seek_cur
tfm = (quat 0 0 0 1) as matrix3
tfm.row4 = [b1x,b1y,b1z]
if isvalidnode (getNodeByName BName) == true Do (
append BNArr (getNodeByName BName)
)
if isvalidnode (getNodeByName BName) != true Do (
	
 if (bparent != 0) do (
tfm = tfm * BNArr[bparent].objecttransform
 )	

	newBone = bonesys.createbone	\
				  tfm.row4	\
				  (tfm.row4 + 0.01 * (normalize tfm.row1)) \
				  (normalize tfm.row3)

			newBone.name   = BName
			newBone.width  = 0.03
			newBone.height = 0.03
			newBone.transform = tfm
			newBone.wirecolor = yellow
			newbone.showlinks = true
			newBone.setBoneEnable false 0
			newBone.pos.controller      = TCB_position ()
			newBone.rotation.controller = TCB_rotation ()
 if (bparent != 0) then
 newBone.parent = BNArr[bparent]
append BNArr newBone
 
				  )
)

struct VertCount_Info_Struct
(
	FaceSecCount,FaceSecStart,VertID,BonePalletID,VCount,BBPosX,BBPosY,BBPosZ
)
VertCount_Info_Array = #()
fseek f VertCountOff#seek_set
for a = 1 to MeshCount2 Do (
unk1 = ReadBELong f
unk2 = ReadBELong f
FaceSecCount = ReadBELong f
FaceSecStart = ReadBELong f
VertID = ReadBELong f
BonePalletID = ReadBELong f
VCount = ReadBELong f
Null1 = ReadBELong f
BBMaxX = ReadBEfloat f
BBMaxY = ReadBEfloat f
BBMaxZ = ReadBEfloat f
BBMaxW = ReadBEfloat f
BBMinX = ReadBEfloat f
BBMinY = ReadBEfloat f
BBMinZ = ReadBEfloat f
BBMinW = ReadBEfloat f
BBPosX = ReadBEfloat f
BBPosY = ReadBEfloat f
BBPosZ = ReadBEfloat f
BBPosW = ReadBEfloat f
--print [BBMaxX,BBMaxY,BBMaxZ,BBMaxW]
--print [BBMinX,BBMinY,BBMinZ,BBMinW]
--print [BBPosX,BBPosY,BBPosZ,BBPosW]
append VertCount_Info_Array (VertCount_Info_Struct FaceSecCount:FaceSecCount FaceSecStart:FaceSecStart VertID:VertID BonePalletID:BonePalletID VCount:VCount BBPosX:BBPosX BBPosY:BBPosY BBPosZ:BBPosZ)
)
print VertCount_Info_Array


struct FaceCount_Info_Struct
(
	FaceType,FCount,FStart,FGroup
)
FaceCount_Info_Array = #()

fseek f FaceCountOff#seek_set
for a = 1 to FaceCount Do (
FaceType = ReadBEword f
	printoffset (FaceType)
FCount = ReadBEword f
FStart = ReadBELong f
FGroup = ReadBELong f
Unk02 = ReadBELong f
append FaceCount_Info_Array (FaceCount_Info_Struct FaceType:FaceType FCount:FCount FStart:FStart FGroup:FGroup)	
)
print FaceCount_Info_Array

struct VertCount2_Info_Struct
(
	UsedVertDef,VSize,VStart
)
VertCount2_Info_Array = #()

for a = 1 to MeshCount2 Do (
Unk03 = ReadBELong f
UsedVertDef = ReadBELong f
VSize = ReadBELong f
VStart = ReadBELong f
fseek f 0x20#seek_cur
append VertCount2_Info_Array (VertCount2_Info_Struct UsedVertDef:UsedVertDef VSize:VSize VStart:VStart)
)
print VertCount2_Info_Array

struct Bone_Info_Struct
(
	Bone1,Bone2,Bone3,Bone4
)
struct Weight_Info_Struct
(
	Weight1,Weight2,Weight3,Weight4
)

for a = 1 to MeshCount2 Do (
Vert_array     = #()
Normal_array  = #()
UV_array       = #()
UV_array2      = #()
Face_array    = #()
Weight_array = #()
vdef_Array    = #()
vpos_Array    = #()
W1_array = #()
B1_array = #()
fseek f (VertSizeOff + ((a - 1) * 0x30))#seek_set
Unk03 = ReadBELong f
UsedVertDef = ReadBELong f
VSize = ReadBELong f
VStart = ReadBELong f
for b = 1 to UsedVertDef Do (
vdef = readbyte f#unsigned
append vdef_Array vdef
)
fseek f (0x10 - UsedVertDef)#seek_cur
for b = 1 to UsedVertDef Do (
vpos = readbyte f#unsigned
append vpos_Array vpos
)
fseek f (0x10 - UsedVertDef)#seek_cur
print vdef_Array
fseek f (VertStart + VStart)#seek_set	
for b = 1 to VertCount_Info_Array[a].VCount Do (
vstart = (ftell f)
for c = 1 to vdef_Array.count do (
if vdef_Array[c] == 16 Do (
vx = ReadBEfloat f
vy = ReadBEfloat f
vz = ReadBEfloat f
append Vert_array [vx,vy,vz]
)
if vdef_Array[c] == 120 Do (
fseek f (vstart + vpos_Array[c])#seek_set
tu = ReadBEHalfFloat f
tv = ReadBEHalfFloat f * -1
append UV_array [tu,tv,0]
)

if vdef_Array[c] == 121 Do (

)
if vdef_Array[c] == 122 Do (
	
)
if vdef_Array[c] == 123 Do (

)
if vdef_Array[c] == 124 Do (
	
)
if vdef_Array[c] == 125 Do (

)
if vdef_Array[c] == 129 Do (
fseek f (vstart + vpos_Array[c])#seek_set
weight1 = readbyte f#unsigned / 255
weight2 = readbyte f#unsigned / 255
weight3 = readbyte f#unsigned / 255
weight4 = readbyte f#unsigned / 255
append W1_array (Weight_Info_Struct Weight1:Weight1 Weight2:Weight2 Weight3:Weight3 Weight4:Weight4)
)
if vdef_Array[c] == 131 Do (
ColorR = readbyte f#unsigned
ColorG = readbyte f#unsigned
ColorB = readbyte f#unsigned
ColorA = readbyte f#unsigned	
)
if vdef_Array[c] == 151 Do (
fseek f (vstart + vpos_Array[c])#seek_set
bone1 = readbyte f#unsigned
bone2 = readbyte f#unsigned
bone3 = readbyte f#unsigned
bone4 = readbyte f#unsigned
append B1_array (Bone_Info_Struct Bone1:Bone1 Bone2:Bone2 Bone3:Bone3 Bone4:Bone4)
)
if vdef_Array[c] == 162 Do (
nx = readbyte f#unsigned
ny = readbyte f#unsigned
nz = readbyte f#unsigned
nw = readbyte f#unsigned	
)
if vdef_Array[c] == 174 Do (
nx = readbyte f#unsigned
ny = readbyte f#unsigned
nz = readbyte f#unsigned
nw = readbyte f#unsigned		
)
fseek f (vstart + VertCount2_Info_Array[a].vsize)#seek_set
)

)
for c = (VertCount_Info_Array[a].FaceSecStart + 1) to (VertCount_Info_Array[a].FaceSecStart + VertCount_Info_Array[a].FaceSecCount) Do (
fseek f (FaceStart + FaceCount_Info_Array[c].FStart)#seek_set


for d = 1 to (FaceCount_Info_Array[c].FCount / 3) Do (
f1 = (ReadBEword f) + 1
f2 = (ReadBEword f) + 1
f3 = (ReadBEword f) + 1
append Face_array [f1,f3,f2]
)

)
if UV_array.count == 0 Do (
for b = 1 to Vert_array.count Do (
append UV_array [0,0,0]
)
for b = 1 to W1_array.count Do (
w = (weight_data boneids:#() weights:#())
maxweight = 0
   
if(W1_array[b].Weight1 != 0) then
   maxweight = maxweight + W1_array[b].Weight1
if(W1_array[b].Weight2 != 0) then
   maxweight = maxweight + W1_array[b].Weight2
if(W1_array[b].Weight3 != 0) then
   maxweight = maxweight + W1_array[b].Weight3
if(W1_array[b].Weight4 != 0) then
   maxweight = maxweight + W1_array[b].Weight4

if(maxweight != 0) then
   (
      if(W1_array[b].Weight1 != 0) then
      (
         w1 = W1_array[b].Weight1 as float
         append w.boneids (B1_array[b].Bone1 + 1)
         append w.weights (w1)
      )
      if(W1_array[b].Weight2 != 0) then
      (
         w2 = W1_array[b].Weight2 as float
         append w.boneids (B1_array[b].Bone2 + 1)
         append w.weights (w2)
      )
      if(W1_array[b].Weight3 != 0) then
      (
         w3 = W1_array[b].Weight3 as float
         append w.boneids (B1_array[b].Bone3 + 1)
         append w.weights (w3)
      )
      if(W1_array[b].Weight4 != 0) then
      (
         w4 = W1_array[b].Weight4 as float
         append w.boneids (B1_array[b].Bone4 + 1)
         append w.weights (w4)
      )      
   )
append Weight_array w
)
)
--Face_array = #()
msh = mesh vertices:Vert_array faces:Face_array
msh.numTVerts = UV_array.count
buildTVFaces msh
for j = 1 to UV_array.count do setTVert msh j UV_array[j]
for j = 1 to Face_array.count do setTVFace msh j Face_array[j]
for j = 1 to Normal_array.count do setNormal msh j Normal_array[j]
if BNArr.count >= 1 Do (
BonePallet_Array = #()
select msh
msh.pos = msh.pos + BNArr[1].pos
fseek f (BonePalletOff + (VertCount_Info_Array[a].BonePalletID * 0x28))#seek_set
unk01 = ReadBELong f
bcount = ReadBEword f
null01 = ReadBEword f
for d = 1 to bcount Do (
usedbone = readbyte f#unsigned + 1
append BonePallet_Array BNArr[usedbone]
)

max modify mode
skinMod = skin ()
addModifier msh skinMod
print BonePallet_Array.count
print BonePallet_Array
for i = 1 to  BonePallet_Array.count do
(
        maxbone = BonePallet_Array[i]
        if i !=  BonePallet_Array.count then
                skinOps.addBone skinMod maxbone 0
        else
                skinOps.addBone skinMod maxbone 1
        
)
modPanel.setCurrentObject skinMod

for i = 1 to Weight_array.count do (
        w = Weight_array[i]
        bi = #()
        wv = #()
        
        for j = 1 to w.boneids.count do
        (
                boneid = w.boneids[j]
                weight = w.weights[j]
                append bi boneid
                append wv weight
        )       
        skinOps.ReplaceVertexWeights skinMod i bi wv
)
max create mode
)

)
fclose f